/* Standard icon resource IDs */

#define IDI_APPLICATION     32512
#define IDI_HAND            32513
#define IDI_QUESTION        32514
#define IDI_EXCLAMATION     32515
#define IDI_ASTERISK        32516

#define COLOR_BTNFACE       15
#define EM_SETSEL           177

#define MF_BYPOSITION       1024 
#define MF_DISABLED         2

#include "fivewin.ch"

/*
FUNCTION MyMsgBox(  lPosition, aRect, cMsg, aOptions, cTitle, xIcon, nDefault, aGradiate,  
                    lGradDir, cBrush, bAction, oFont, nFColor, cFileRes, oIcon, uVar, cPict, bValid,
                    lSpinner, lMeter, oMeter, lCancel)                 
AUTHOR : P.Ramesh Babu                                                    
CREDITS: This function is derived from the FWH's ALERT.PRG              ***
*/

FUNCTION MyMsgBox( lPosition, aRect, cMsg, aOptions, cTitle, xIcon, nDefault, aGradiate,  ;
                   lGradDir, cBrush, bAction, oFont, nFColor, cFileRes, oIcon, uVar, cPict, bValid,;
                   lSpinner, lMeter, oMeter, lCancel)

LOCAL oBrush
LOCAL oDlg, oIco
LOCAL nFund := 1, hDC, hBmp
LOCAL lLoaded := .F.

DEFAULT cMsg := "Alert dialog box", ;
		aOptions := {"&OK"}, ;
		cTitle    := "Attention", ;
		nDefault  :=  1, ;
		nFColor :=  0, ;
		lGradDir := .T., ; 
		cBrush := "", ;
		lMeter    := .F., ;
		aGradiate := {{1,CLR_WHITE, nRgb(183,172,234)},{1,CLR_WHITE, nRgb(183,172,234)}} // VIOLET

IF oFont = nil
	DEFINE FONT oFont NAME "Ms Sans Serif" SIZE 0, -10
ENDIF

IF EMPTY( cBrush )
	DEFINE BRUSH oBrush
	DEFINE DIALOG oDlg TITLE cTitle FONT oFont TRANSPARENT BRUSH oBrush ;
        COLOR CLR_BLUE, CLR_WHITE       
ELSE
	DEFINE BRUSH oBrush FILE cBrush
        DEFINE DIALOG oDlg TITLE cTitle FONT oFont TRANSPARENT  
        SET BRUSH OF oDlg TO oBrush
ENDIF

IF oIcon # nil
	oDlg:oIcon := oIcon
ENDIF

oDlg:Cargo     := 0
oDlg:lHelpIcon := .F.

IF .NOT. EMPTY(cFileRes)
	xIcon := ""
ELSE
	IF EMPTY(xIcon)
		xIcon := "A"
	ENDIF
	IF UPPER(xIcon) = "E"
		xIcon := IDI_APPLICATION
	ELSEIF UPPER(xIcon) = "A"
		xIcon := IDI_ASTERISK
	ELSEIF UPPER(xIcon) = "X"
		xIcon := IDI_HAND
	ELSEIF UPPER(xIcon) = "Q"
		xIcon := IDI_QUESTION
	ELSEIF UPPER(xIcon) = "I"
		xIcon := IDI_EXCLAMATION
	ENDIF
ENDIF

IF bAction == NIL
ELSE
	IF.NOT. lMeter
		aOptions := {}
	ELSE
		aOptions := {"&Cancel"}
	ENDIF
ENDIF

IF .NOT. EMPTY(cFileRes)
	oDlg:bPainted := {||PaintBmp(oDlg, cFileRes, 12, 12)}
ENDIF

ACTIVATE DIALOG oDlg CENTERED ;
ON INIT ( DlgInit(oDlg, lPosition, aRect, oFont, nFColor, cMsg, aOptions, cTitle, nDefault,;
	        aGradiate, lGradDir, cBrush, bAction, xIcon, @uVar, cPict, bValid,;
		lSpinner, lMeter, oMeter, @lCancel),;
		IIF( EMPTY(cBrush), gradiate(oDlg, aGradiate, lGradDir), NIL ))	 

IF oIco # nil
	RELEASE ICON oIco
ENDIF

RELEASE FONT  oFont
RELEASE BRUSH oBrush

RETURN oDlg:Cargo

/*
STATIC FUNCTION DlgInit(oDlg,lPosition,aRect,oFont,nFColor,cMsg,aOptions,cTitle,xIcon,nDefault,;) 
                aGradiate, lGradDir, cBrush, bAction, xIcon) Used by YesNo() Function       
*/

STATIC FUNCTION DlgInit( oDlg, lPosition, aRect, oFont, nFColor, cMsg, aOptions, cTitle, nDefault,;
					     aGradiate, lGradDir, cBrush, bAction, xIcon, uVar, cPict, bValid,;
                                             lSpinner, lMeter, oMeter, lCancel )

LOCAL oSay, oBtn, oIcon, oGet, uOldVal, lEnd := .F. 
LOCAL cSay, cLine, aSay := {}, aBmpPal, hBitmap, nVal := 0
LOCAL nMaxWidth, nMaxHeight, nWidth, nHeight, nLines, nFor, nRow
LOCAL nBtnWidth, nBtnOffset, nBtnHeight, nBtnLength
LOCAL lHScroll, lVScroll, lPadded := .F., lPaded := .F.
LOCAL aBtns := ARRAY(LEN(aOptions)), aCoors

IF ValType( cMsg ) != "C"
	cMsg := cValToChar( cMsg )
ENDIF

nDefault   := 1
aCoors     := GetCoors(GetDeskTopWindow())
cSay       := ""
nMaxWidth  := 0
nMaxHeight := 0
nLines     := MLCOUNT(cMsg, 254)

IF uVar # nil .OR. lMeter
	nLines := nLines + IF(lMeter,4,2)
ENDIF

FOR nFor := 1 TO nLines
	cLine := TRIM(Memoline(cMsg, 254, nFor))
	AADD(aSay, cLine)
	cSay += cLine+CRLF
	nMaxHeight += oDlg:nGetChrHeight()
	nMaxWidth  := Max(nMaxWidth, oDlg:GetWidth(cLine))
NEXT

aSay    := ARRAY(LEN(aSay))

nWidth  := nMaxWidth
nHeight := nMaxHeight

IF nHeight > 400
	nHeight := 400
ENDIF

IF nWidth > 500
   nWidth := 500
ENDIF

IF .NOT. EMPTY(xIcon)
	@ .75, 18/12 ICON oIcon OF oDlg
	oIcon:hIcon := LoadIcon(oDlg, xIcon)
	oIcon:SetBrush( TBrush():New(" NULL" ) )
ENDIF

@ 20, 70 SAY oSay VAR cSay OF oDlg  ;
SIZE nWidth, nHeight PIXEL ;
COLOR nFColor FONT oFont TRANSPARENT

IF bAction # nil
	SysRefresh()
ENDIF

nMaxWidth := Max(nWidth + 90, oDlg:GetWidth(cTitle) + 90)
nBtnWidth := 70

FOR nFor := 1 TO LEN(aOptions)
	nBtnWidth := Max(nBtnWidth, oDlg:GetWidth(aOptions[nFor]))
NEXT

* Save old Value before editing
IF uVar # nil
	uOldVal := uVar
ENDIF

nBtnLength := ( LEN(aOptions) * nBtnWidth ) - IF(LEN(aOptions) > 1, 4,0)
nBtnHeight := Max(nHeight, 30) + 30
nMaxHeight := (oDlg:nGetChrHeight()*1.7) + nBtnHeight + 10 + IF(bAction == NIL,40,0) + 5
nMaxWidth  := Max(nMaxWidth, nBtnLength+59+(8*LEN(aOptions)))
nBtnOffset := ROUND((nMaxWidth-nBtnLength) / 2,0) - ((8*LEN(aOptions))/2)

IF lMeter
	nBtnHeight -= 25
ENDIF

FOR nFor := 1 TO LEN(aOptions)
	@ nBtnHeight, nBtnOffset + ((nFor-1)*nBtnWidth) ;
	BTNBMP aBtns[nFor] PROMPT aOptions[nFor] OF oDlg  ;
	PIXEL SIZE nBtnWidth, oDlg:nGetChrHeight() * 2 CENTER  2007               

	nBtnOffset   := nBtnOffset + 8
	aBtns[nFor]:bAction := GenBlock(oDlg, nFor)
NEXT nFor

IF uVar # nil
	aBtns[1]:bAction := {||oDlg:Cargo := uVar, oDlg:End()}
	aBtns[2]:bAction := {||oDlg:Cargo := uOldVal, oDlg:End()}

	 IF VALTYPE(uVar) == "D"
		nWidth := 60
	ELSE
		nWidth := nMaxWidth*.6
	ENDIF

	IF VALTYPE(uVar) $ "ND"
		@ 20+(oDlg:nGetChrHeight()*1.5), 60 GET oGet VAR uVar OF oDlg PIXEL SIZE nWidth,18 SPINNER RIGHT
	ELSE
		@ 20+(oDlg:nGetChrHeight()*1.5), 60 GET oGet VAR uVar OF oDlg PIXEL SIZE nWidth,18
	ENDIF 

	IF bValid # nil
		oGet:bValid := bValid
	ENDIF

	IF cPict # nil
		oGet:cPicture := cPict
	ENDIF

ELSEIF lMeter

	aBtns[1]:bAction := {||lCancel := .T.}

	@ 20+(oDlg:nGetChrHeight()*1.5), 60  METER oMeter VAR nVal TOTAL 10 SIZE nWidth, 18 OF oDlg PIXEL 

ENDIF

IF nDefault > LEN(oDlg:aControls) .OR. nDefault = NIL
	nDefault := 2
ENDIF

IF bAction == NIL
	oDlg:Move(0,0,nMaxWidth,nMaxHeight-6.25)
ELSE
	oDlg:Move(0,0,nMaxWidth,nMaxHeight)
ENDIF

IF lPosition = .T.
	oDlg:Move( aRect[1] + ( aRect[3] / 2 ) - ( nMaxHeight / 2 ), ;
                           aRect[2]  + ( aRect[4] / 2 ) - ( nMaxWidth / 2 ), , , .f. )
ELSE
	WndCenter(oDlg:hWnd)
ENDIF

IF bAction == NIL
	oDlg:bStart := {|| ( DisableX(oDlg,.T.), SetFocus(aBtns[1]) ) }
ELSE
	IF .NOT. lMeter
		oDlg:bStart := {|| ( DisableX(oDlg,.T.), oDlg:lHelpIcon := .F.,;
					SysRefresh(), Eval( bAction ),    ;
					oDlg:End(), SysRefresh()  ) }
	ELSE
		oDlg:bStart := {|| ( DisableX(oDlg,.T.), oDlg:lHelpIcon := .F.,;
					SysRefresh(), Eval( bAction, oMeter, @lCancel, aBtns[1]),    ;
					oDlg:Cargo := !lCancel, oDlg:End(), SysRefresh())}
	ENDIF
ENDIF

SysRefresh()

RETURN nil

// FUNCTION DisableX(oWin, lDisable) - To Disable 'X' Button of a Dialog   

FUNCTION DisableX(oWin, lDisable)

LOCAL hMenu  := 0
LOCAL nCount := 0

DEFAULT lDisable := .T.

IF lDisable
	hMenu  = GetSystemMenu(oWin:hWnd, .F.)
	nCount = GetMItemCount(hMenu)
	IF oWin:ClassName() = "TDIALOG"
		RemoveMenu(hMenu, 1, nOR( MF_BYPOSITION, MF_DISABLED) )
	ELSE
		RemoveMenu(hMenu, nCount - 1, nOR( MF_BYPOSITION, MF_DISABLED) )   // Close Button
	ENDIF
	DrawMenuBar( oWin:hWnd )
ELSE
	GetSystemMenu( oWin:hWnd, .T. )
	DrawMenuBar( oWin:hWnd )
ENDIF

IF oWin:bValid = nil
	oWin:bValid := (.F.)
ENDIF

RETURN nil

// STATIC FUNCTION GenBlock(oDlg, nElem) to Create a Code Block            

STATIC FUNCTION GenBlock(oDlg, nElem)
RETURN { || oDlg:Cargo := nElem, oDlg:End() }

// FUNCTION Gradiate( oDlg, aColors, nGradPos, lGradDir ) Paint a Dialog with Gradiant Colors*

FUNCTION Gradiate( oDlg, aColors,lGradDir )

LOCAL hDC, hBmp, hBmpOld , nWidth , nHeight

DEFAULT lGradDir := .T.

IF EMPTY( oDlg:oBrush:hBitmap )
	nHeight := IF(lGradDir,oDlg:nHeight,1)
	nWidth  := IF(lGradDir,1,oDlg:nWidth)
	hDC     := CreateCompatibleDC( oDlg:GetDC() )
	hBmp    := CreateCompatibleBitMap( oDlg:hDC, nWidth, nHeight )
	hBmpOld := SelectObject( hDC, hBmp )
	GradientFill( hDC, 0, 0, nHeight, nWidth, aColors,lGradDir )
	DeleteObject( oDlg:oBrush:hBrush )
	oDlg:oBrush:hBitmap := hBmp
	oDlg:oBrush:hBrush  := CreatePatternBrush( hBmp )
	SelectObject( hDC, hBmpOld )
	oDlg:ReleaseDC()
ENDIF

RETURN nil

// FUNCTION PaintBmp(oDlg,row,col) to Paint a Transparent Bitmap directly  
//                                on a Dialog/Window from a File/Resource  

FUNCTION PaintBmp(oDlg, cFileRes, nRow, nCol)

LOCAL aBmpPal, hBitmap

IF FILE(cFileRes)
	// This Code is for reading bitmap file from disk file
	aBmpPal = PalBmpRead(oDlg:hDC, cFileRes )
ELSE
	// This Code is for reading bitmap file resource
	aBmpPal = PalBmpLoad( cFileRes )
ENDIF

hBitmap = aBmpPal[ 1 ]

DrawMasked( oDlg:hDC, hBitmap, nRow, nCol )

RETURN hBitMap
